package yhg.comm.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Enumeration;
import java.util.Hashtable;

import yhg.comm.message.Message;

/**
 * 
 * 
 * @author	Yoon HyunGook
 * @since	2010-03-08
 */
public class CommServer extends Thread {
	private Hashtable<Integer,CommClientManager> clientList = new Hashtable<Integer,CommClientManager>();
	private ServerSocket server;
	private ICommClientManagerEvent clientEvent;
	private ICommServerEvent serverEvent;
	private int number = 0;
	
	/**
	 * 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ʈ
	 */
	public CommServer(int port) throws IOException {
		server = new ServerSocket(port);
	}
	
	/**
	 * Ŭ̾Ʈ Ŵ ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	̺Ʈ
	 */
	public void setClientManagerEvent(ICommClientManagerEvent rec){
		clientEvent = rec;
	}
	
	/**
	 *  ̺Ʈ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	̺Ʈ
	 */
	public void setServerEvent(ICommServerEvent apt){
		serverEvent = apt;
	}
	
	/**
	 *  
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 */
	public void run(){
		System.out.println("-- start server --");
		
		while(true){
			try {
				final Socket clientSock = server.accept();
				CommClientManager client = new CommClientManager(this, clientSock, ++number);
				clientList.put(number, client);
				client.setClientManagerEvent(clientEvent);
				
				serverEvent.onEnterClient(client);
				
				client.start();
			} catch (IOException e) {
				try {
					server.close();
					System.out.println("-- close server --");
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		}
	}
	
	/**
	 *   Ŭ̾Ʈ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	޼
	 */
	public void sendAll(Message msg) throws IOException{
		for(int i=0; i<clientList.size(); i++){
			clientList.get(i).send(msg);
		}
	}
	
	/**
	 *  Ŭ̾Ʈ   Ŭ̾Ʈ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	 Ŭ̾Ʈ ȣ
	 * @param	޼
	 */
	public void sendAll(int num, Message msg) throws IOException{
		Enumeration<CommClientManager> list = clientList.elements();
		
		while(list.hasMoreElements()){
			CommClientManager cm = list.nextElement();
			
			if(num == cm.getNumber())	continue;			
			cm.send(msg);
		}
	}
	
	/**
	 *  Ŭ̾ƮԸ ޼ 
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	Ŭ̾Ʈ ȣ
	 * @param	޼
	 */
	public void sendTo(int num, Message msg) throws IOException{
		clientList.get(num).send(msg);
	}
	
	/**
	 * Ŭ̾Ʈ   ̺Ʈ
	 * 
	 * @author	Yoon HyunGook
	 * @since	2010-03-08
	 * 
	 * @param	CommClientManager ü
	 */
	protected void onLeaveClient(CommClientManager cm){
		serverEvent.onLeaveClient(cm);
		clientList.remove(cm.getNumber());
	}
}
